import { ModuleWithProviders, NgZone } from '@angular/core';
import { LogService } from '@blaugold/angular-logger';
import { FirebaseAuthService } from './firebase-auth.service';
import { FirebaseDatabaseService } from './firebase-database.service';
export interface FirebaseAppConfig {
    name?: string;
    config: {
        apiKey: string;
        authDomain: string;
        databaseURL: string;
        storageBucket: string;
        messagingSenderId: string;
    };
}
export declare function invokeLazy(): boolean;
export declare class FirebaseModule {
    static forRoot(config: FirebaseAppConfig[], lazyInvocation?: boolean): ModuleWithProviders;
}
export declare class Firebase {
    private configs;
    private ngZone;
    static lastInstanceId: number;
    apps: {
        [appName: string]: {
            auth: FirebaseAuthService;
            database: FirebaseDatabaseService;
        };
    };
    private instId;
    private defaultAppName;
    private logger;
    static getProjectName(config: FirebaseAppConfig): string;
    constructor(configs: FirebaseAppConfig[], ngZone: NgZone, logService: LogService);
    auth(appName?: string): FirebaseAuthService;
    database(appName?: string): FirebaseDatabaseService;
    private assertAppExists(appName);
    private hasApp(appName);
}
